image: docker:19.03.1
services:
    - docker:19.03.1-dind

stages:
    - build
    - release

variables:
    # Use TLS https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#tls-enabled
    DOCKER_HOST: tcp://docker:2376
    DOCKER_TLS_CERTDIR: "/certs"
    BUILD_TAG_OTP: $CI_REGISTRY_IMAGE:otp_$CI_COMMIT_REF_SLUG
    RELEASE_TAG_OTP: $CI_REGISTRY_IMAGE:otp_latest
    BUILD_TAG_FE: $CI_REGISTRY_IMAGE:fe_$CI_COMMIT_REF_SLUG
    RELEASE_TAG_FE: $CI_REGISTRY_IMAGE:fe_latest

before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

build:
    stage: build
    script:
      - docker build -t $BUILD_TAG_OTP otpservice
      - docker push $BUILD_TAG_OTP
      - docker build --build-arg rails_master_key=$RAILS_MASTER_KEY -t $BUILD_TAG_FE frontend
      - docker push $BUILD_TAG_FE

release:
    stage: release
    script:
      - docker pull $BUILD_TAG_OTP
      - docker tag $BUILD_TAG_OTP $RELEASE_TAG_OTP
      - docker push $RELEASE_TAG_OTP
      - docker pull $BUILD_TAG_FE
      - docker tag $BUILD_TAG_FE $RELEASE_TAG_FE
      - docker push $RELEASE_TAG_FE
    only:
      - master
